<template>
  <div>
    <BasicTable @register="registerTable">
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'type'">
          <Tag :color="formatDictColor(typeOptions, record.type)">
            {{ formatDictValue(typeOptions, record.type) }}
          </Tag>
        </template>
        <template v-if="column.key === 'action'">
          <TableAction
            :actions="[
              {
                auth: 'sys:portal:query',
                icon: 'icon-eye|iconfont',
                tooltip: '查看',
                label: '查看',
                onClick: handleView.bind(null, record),
              },
              {
                auth: 'sys:portal:assign',
                icon: 'icon-setting|iconfont',
                tooltip: '分配菜单',
                label: '分配菜单',
                onClick: handlePortalMenu.bind(null, record),
                ifShow: record.type != 'sys',
              },
              {
                auth: 'sys:portal:edit',
                ifShow: record.type != 'sys',
                icon: 'icon-edit|iconfont',
                tooltip: '编辑',
                label: '编辑',
                onClick: handleEdit.bind(null, record),
              },
              {
                auth: 'sys:portal:remove',
                ifShow: record.type != 'sys',
                icon: 'icon-delete|iconfont',
                tooltip: '删除',
                label: '删除',
                color: 'error',
                popConfirm: {
                  title: '是否确认删除',
                  placement: 'left',
                  confirm: handleDelete.bind(null, record),
                },
              },
            ]"
          />
        </template>
      </template>
      <template #toolbar>
        <Button
          v-auth="['sys:portal:add']"
          type="primary"
          @click="handleCreate"
          preIcon="icon-plus|iconfont"
        >
          新增
        </Button>
        <Button
          v-auth="['sys:portal:remove']"
          type="primary"
          danger
          @click="handleDelete(null)"
          preIcon="icon-delete|iconfont"
        >
          批量删除
        </Button>
      </template>
    </BasicTable>
    <FormDrawer @register="registerDrawer" @success="handleSuccess" />
    <ViewDrawer @register="registerDrawerView" @success="handleSuccess" />
    <FormModalPortalMenu @register="registerModalPortalMenu" />
  </div>
</template>
<script lang="ts" setup>
  import { onBeforeMount, ref } from 'vue';
  import { Tag } from 'ant-design-vue';
  import { Button } from '/@/components/Button';

  import { BasicTable, useTable, TableAction } from '/@/components/Table';

  import { useModal } from '/@/components/Modal';
  import { useMessage } from '/@/hooks/web/useMessage';
  import FormDrawer from './formDrawer.vue';
  import ViewDrawer from './viewDrawer.vue';
  import FormModalPortalMenu from './FormModalPortalMenu.vue';
  import { columns, searchFormSchema } from './data';

  import { sysPortalQueryPage, sysPortalRemove } from '/@/api/sys/sysPortalApi';
  import { listDictModel } from '/@/api/common';
  import { formatDictColor, formatDictValue } from '/@/utils';
  import { useDrawer } from '/@/components/Drawer';

  const typeOptions = ref();
  onBeforeMount(async () => {
    typeOptions.value = await listDictModel({ dictCode: 'sys_create_type' });
  });

  const { createConfirm, createMessage } = useMessage();
  // const [registerModal, { openModal }] = useModal();
  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerDrawerView, { openDrawer: openDrawerView }] = useDrawer();
  const [registerModalPortalMenu, { openModal: openModalPortalMenu }] = useModal();

  const tableSort = ref([
    {
      field: 'create_time',
      direction: 'DESC',
    },
  ]) as any;

  const [registerTable, { reload, getSelectRowKeys, clearSelectedRowKeys }] = useTable({
    title: ' ',
    api: sysPortalQueryPage,
    rowKey: 'id',
    columns,
    showIndexColumn: true,
    rowSelection: { type: 'checkbox' },
    formConfig: {
      labelWidth: 120,
      schemas: searchFormSchema,
      autoSubmitOnEnter: true,
      baseColProps: { xs: 24, sm: 12, md: 12, lg: 8 },
      resetButtonOptions: {
        preIcon: 'icon-delete|iconfont',
      },
      submitButtonOptions: {
        preIcon: 'icon-search|iconfont',
      },
    },
    useSearchForm: true,
    bordered: true,
    actionColumn: {
      width: 320,
      title: '操作',
      dataIndex: 'action',
    },
    beforeFetch: handleBeforeFetch,
    sortFn: handleSortFn,
  });
  // 详情按钮事件
  function handleView(record: Recordable) {
    console.log(record);
    openDrawerView(true, {
      record,
    });
  }

  // 新增按钮事件
  function handleCreate() {
    openDrawer(true, {
      isUpdate: false,
    });
  }

  // 编辑按钮事件
  function handleEdit(record: Recordable) {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  }

  // 删除按钮事件
  async function handleDelete(record: Recordable) {
    if (record) {
      await sysPortalRemove([record.id]);
      createMessage.success('删除成功！');
      await reload();
    } else {
      const keys = getSelectRowKeys();
      if (keys.length > 0) {
        createConfirm({
          content: '你确定要删除?',
          iconType: 'warning',
          onOk: async () => {
            const keys = getSelectRowKeys();
            await sysPortalRemove(keys);
            createMessage.success('删除成功！');
            await reload();
            clearSelectedRowKeys();
          },
        });
      } else {
        createMessage.warning('请选择要删除的数据');
      }
    }
  }
  // 分配菜单按钮事件
  function handlePortalMenu(record: Recordable) {
    console.log(record);
    openModalPortalMenu(true, {
      record,
    });
  }
  // 表格点击字段排序
  function handleSortFn(sortInfo) {
    if (sortInfo?.order && sortInfo?.columnKey) {
      // 默认单列排序
      tableSort.value = [
        {
          field: sortInfo.columnKey,
          direction: sortInfo.order.replace(/(\w+)(end)/g, '$1').toUpperCase(),
        },
      ];
    }
  }

  // 表格请求之前，对参数进行处理, 添加默认 排序
  function handleBeforeFetch(params) {
    return { ...params, orders: tableSort.value };
  }

  // 弹窗回调事件
  async function handleSuccess({ isUpdate, values }) {
    console.log(isUpdate);
    console.log(values);
    await reload();
  }
</script>
